/*
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.spoonacular.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Arrays;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.spoonacular.client.JSON;

/**
 * GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-08T10:10:15.275701200+01:00[Europe/Berlin]")
public class GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner {
  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_AMOUNT = "amount";
  @SerializedName(SERIALIZED_NAME_AMOUNT)
  private BigDecimal amount;

  public static final String SERIALIZED_NAME_UNIT = "unit";
  @SerializedName(SERIALIZED_NAME_UNIT)
  private String unit;

  public static final String SERIALIZED_NAME_PERCENT_DAILY_NEEDS = "percentDailyNeeds";
  @SerializedName(SERIALIZED_NAME_PERCENT_DAILY_NEEDS)
  private BigDecimal percentDailyNeeds;

  public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner() {
  }

  public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @javax.annotation.Nonnull
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }


  public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner amount(BigDecimal amount) {
    this.amount = amount;
    return this;
  }

   /**
   * Get amount
   * @return amount
  **/
  @javax.annotation.Nonnull
  public BigDecimal getAmount() {
    return amount;
  }

  public void setAmount(BigDecimal amount) {
    this.amount = amount;
  }


  public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner unit(String unit) {
    this.unit = unit;
    return this;
  }

   /**
   * Get unit
   * @return unit
  **/
  @javax.annotation.Nonnull
  public String getUnit() {
    return unit;
  }

  public void setUnit(String unit) {
    this.unit = unit;
  }


  public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner percentDailyNeeds(BigDecimal percentDailyNeeds) {
    this.percentDailyNeeds = percentDailyNeeds;
    return this;
  }

   /**
   * Get percentDailyNeeds
   * @return percentDailyNeeds
  **/
  @javax.annotation.Nonnull
  public BigDecimal getPercentDailyNeeds() {
    return percentDailyNeeds;
  }

  public void setPercentDailyNeeds(BigDecimal percentDailyNeeds) {
    this.percentDailyNeeds = percentDailyNeeds;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner getMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner = (GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner) o;
    return Objects.equals(this.name, getMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.name) &&
        Objects.equals(this.amount, getMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.amount) &&
        Objects.equals(this.unit, getMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.unit) &&
        Objects.equals(this.percentDailyNeeds, getMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.percentDailyNeeds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, amount, unit, percentDailyNeeds);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner {\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    unit: ").append(toIndentedString(unit)).append("\n");
    sb.append("    percentDailyNeeds: ").append(toIndentedString(percentDailyNeeds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("name");
    openapiFields.add("amount");
    openapiFields.add("unit");
    openapiFields.add("percentDailyNeeds");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("name");
    openapiRequiredFields.add("amount");
    openapiRequiredFields.add("unit");
    openapiRequiredFields.add("percentDailyNeeds");
  }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      if (jsonElement == null) {
        if (!GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.openapiRequiredFields.isEmpty()) { // has required fields but JSON element is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner is not found in the empty JSON string", GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.openapiRequiredFields.toString()));
        }
      }

      Set<Map.Entry<String, JsonElement>> entries = jsonElement.getAsJsonObject().entrySet();
      // check to see if the JSON string contains additional fields
      for (Map.Entry<String, JsonElement> entry : entries) {
        if (!GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner` properties. JSON: %s", entry.getKey(), jsonElement.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.openapiRequiredFields) {
        if (jsonElement.getAsJsonObject().get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonElement.toString()));
        }
      }
        JsonObject jsonObj = jsonElement.getAsJsonObject();
      if (!jsonObj.get("name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("name").toString()));
      }
      if (!jsonObj.get("unit").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `unit` to be a primitive type in the JSON string but got `%s`", jsonObj.get("unit").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.class));

       return (TypeAdapter<T>) new TypeAdapter<GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner>() {
           @Override
           public void write(JsonWriter out, GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner read(JsonReader in) throws IOException {
             JsonElement jsonElement = elementAdapter.read(in);
             validateJsonElement(jsonElement);
             return thisAdapter.fromJsonTree(jsonElement);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner
  * @throws IOException if the JSON string is invalid with respect to GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner
  */
  public static GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner.class);
  }

 /**
  * Convert an instance of GetMealPlanWeek200ResponseDaysInnerNutritionSummaryNutrientsInner to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

