/*
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.spoonacular.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.spoonacular.client.model.ImageAnalysisByURL200ResponseNutritionCalories;
import java.io.IOException;
import java.util.Arrays;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.spoonacular.client.JSON;

/**
 * ImageAnalysisByURL200ResponseNutrition
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-08T10:10:15.275701200+01:00[Europe/Berlin]")
public class ImageAnalysisByURL200ResponseNutrition {
  public static final String SERIALIZED_NAME_RECIPES_USED = "recipesUsed";
  @SerializedName(SERIALIZED_NAME_RECIPES_USED)
  private Integer recipesUsed;

  public static final String SERIALIZED_NAME_CALORIES = "calories";
  @SerializedName(SERIALIZED_NAME_CALORIES)
  private ImageAnalysisByURL200ResponseNutritionCalories calories;

  public static final String SERIALIZED_NAME_FAT = "fat";
  @SerializedName(SERIALIZED_NAME_FAT)
  private ImageAnalysisByURL200ResponseNutritionCalories fat;

  public static final String SERIALIZED_NAME_PROTEIN = "protein";
  @SerializedName(SERIALIZED_NAME_PROTEIN)
  private ImageAnalysisByURL200ResponseNutritionCalories protein;

  public static final String SERIALIZED_NAME_CARBS = "carbs";
  @SerializedName(SERIALIZED_NAME_CARBS)
  private ImageAnalysisByURL200ResponseNutritionCalories carbs;

  public ImageAnalysisByURL200ResponseNutrition() {
  }

  public ImageAnalysisByURL200ResponseNutrition recipesUsed(Integer recipesUsed) {
    this.recipesUsed = recipesUsed;
    return this;
  }

   /**
   * Get recipesUsed
   * @return recipesUsed
  **/
  @javax.annotation.Nonnull
  public Integer getRecipesUsed() {
    return recipesUsed;
  }

  public void setRecipesUsed(Integer recipesUsed) {
    this.recipesUsed = recipesUsed;
  }


  public ImageAnalysisByURL200ResponseNutrition calories(ImageAnalysisByURL200ResponseNutritionCalories calories) {
    this.calories = calories;
    return this;
  }

   /**
   * Get calories
   * @return calories
  **/
  @javax.annotation.Nonnull
  public ImageAnalysisByURL200ResponseNutritionCalories getCalories() {
    return calories;
  }

  public void setCalories(ImageAnalysisByURL200ResponseNutritionCalories calories) {
    this.calories = calories;
  }


  public ImageAnalysisByURL200ResponseNutrition fat(ImageAnalysisByURL200ResponseNutritionCalories fat) {
    this.fat = fat;
    return this;
  }

   /**
   * Get fat
   * @return fat
  **/
  @javax.annotation.Nonnull
  public ImageAnalysisByURL200ResponseNutritionCalories getFat() {
    return fat;
  }

  public void setFat(ImageAnalysisByURL200ResponseNutritionCalories fat) {
    this.fat = fat;
  }


  public ImageAnalysisByURL200ResponseNutrition protein(ImageAnalysisByURL200ResponseNutritionCalories protein) {
    this.protein = protein;
    return this;
  }

   /**
   * Get protein
   * @return protein
  **/
  @javax.annotation.Nonnull
  public ImageAnalysisByURL200ResponseNutritionCalories getProtein() {
    return protein;
  }

  public void setProtein(ImageAnalysisByURL200ResponseNutritionCalories protein) {
    this.protein = protein;
  }


  public ImageAnalysisByURL200ResponseNutrition carbs(ImageAnalysisByURL200ResponseNutritionCalories carbs) {
    this.carbs = carbs;
    return this;
  }

   /**
   * Get carbs
   * @return carbs
  **/
  @javax.annotation.Nonnull
  public ImageAnalysisByURL200ResponseNutritionCalories getCarbs() {
    return carbs;
  }

  public void setCarbs(ImageAnalysisByURL200ResponseNutritionCalories carbs) {
    this.carbs = carbs;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageAnalysisByURL200ResponseNutrition imageAnalysisByURL200ResponseNutrition = (ImageAnalysisByURL200ResponseNutrition) o;
    return Objects.equals(this.recipesUsed, imageAnalysisByURL200ResponseNutrition.recipesUsed) &&
        Objects.equals(this.calories, imageAnalysisByURL200ResponseNutrition.calories) &&
        Objects.equals(this.fat, imageAnalysisByURL200ResponseNutrition.fat) &&
        Objects.equals(this.protein, imageAnalysisByURL200ResponseNutrition.protein) &&
        Objects.equals(this.carbs, imageAnalysisByURL200ResponseNutrition.carbs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(recipesUsed, calories, fat, protein, carbs);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageAnalysisByURL200ResponseNutrition {\n");
    sb.append("    recipesUsed: ").append(toIndentedString(recipesUsed)).append("\n");
    sb.append("    calories: ").append(toIndentedString(calories)).append("\n");
    sb.append("    fat: ").append(toIndentedString(fat)).append("\n");
    sb.append("    protein: ").append(toIndentedString(protein)).append("\n");
    sb.append("    carbs: ").append(toIndentedString(carbs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("recipesUsed");
    openapiFields.add("calories");
    openapiFields.add("fat");
    openapiFields.add("protein");
    openapiFields.add("carbs");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("recipesUsed");
    openapiRequiredFields.add("calories");
    openapiRequiredFields.add("fat");
    openapiRequiredFields.add("protein");
    openapiRequiredFields.add("carbs");
  }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to ImageAnalysisByURL200ResponseNutrition
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      if (jsonElement == null) {
        if (!ImageAnalysisByURL200ResponseNutrition.openapiRequiredFields.isEmpty()) { // has required fields but JSON element is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ImageAnalysisByURL200ResponseNutrition is not found in the empty JSON string", ImageAnalysisByURL200ResponseNutrition.openapiRequiredFields.toString()));
        }
      }

      Set<Map.Entry<String, JsonElement>> entries = jsonElement.getAsJsonObject().entrySet();
      // check to see if the JSON string contains additional fields
      for (Map.Entry<String, JsonElement> entry : entries) {
        if (!ImageAnalysisByURL200ResponseNutrition.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ImageAnalysisByURL200ResponseNutrition` properties. JSON: %s", entry.getKey(), jsonElement.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : ImageAnalysisByURL200ResponseNutrition.openapiRequiredFields) {
        if (jsonElement.getAsJsonObject().get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonElement.toString()));
        }
      }
        JsonObject jsonObj = jsonElement.getAsJsonObject();
      // validate the required field `calories`
      ImageAnalysisByURL200ResponseNutritionCalories.validateJsonElement(jsonObj.get("calories"));
      // validate the required field `fat`
      ImageAnalysisByURL200ResponseNutritionCalories.validateJsonElement(jsonObj.get("fat"));
      // validate the required field `protein`
      ImageAnalysisByURL200ResponseNutritionCalories.validateJsonElement(jsonObj.get("protein"));
      // validate the required field `carbs`
      ImageAnalysisByURL200ResponseNutritionCalories.validateJsonElement(jsonObj.get("carbs"));
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ImageAnalysisByURL200ResponseNutrition.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ImageAnalysisByURL200ResponseNutrition' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ImageAnalysisByURL200ResponseNutrition> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ImageAnalysisByURL200ResponseNutrition.class));

       return (TypeAdapter<T>) new TypeAdapter<ImageAnalysisByURL200ResponseNutrition>() {
           @Override
           public void write(JsonWriter out, ImageAnalysisByURL200ResponseNutrition value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ImageAnalysisByURL200ResponseNutrition read(JsonReader in) throws IOException {
             JsonElement jsonElement = elementAdapter.read(in);
             validateJsonElement(jsonElement);
             return thisAdapter.fromJsonTree(jsonElement);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ImageAnalysisByURL200ResponseNutrition given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ImageAnalysisByURL200ResponseNutrition
  * @throws IOException if the JSON string is invalid with respect to ImageAnalysisByURL200ResponseNutrition
  */
  public static ImageAnalysisByURL200ResponseNutrition fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ImageAnalysisByURL200ResponseNutrition.class);
  }

 /**
  * Convert an instance of ImageAnalysisByURL200ResponseNutrition to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

