/*
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.spoonacular;

import com.spoonacular.client.ApiException;
import com.spoonacular.client.model.AddMealPlanTemplate200Response;
import com.spoonacular.client.model.AddToMealPlanRequest;
import com.spoonacular.client.model.AddToMealPlanRequest1;
import com.spoonacular.client.model.AddToShoppingListRequest;
import java.math.BigDecimal;
import com.spoonacular.client.model.ClearMealPlanDayRequest;
import com.spoonacular.client.model.ConnectUser200Response;
import com.spoonacular.client.model.ConnectUserRequest;
import com.spoonacular.client.model.DeleteFromMealPlanRequest;
import com.spoonacular.client.model.GenerateMealPlan200Response;
import com.spoonacular.client.model.GenerateShoppingList200Response;
import com.spoonacular.client.model.GenerateShoppingListRequest;
import com.spoonacular.client.model.GetMealPlanTemplate200Response;
import com.spoonacular.client.model.GetMealPlanTemplates200Response;
import com.spoonacular.client.model.GetMealPlanWeek200Response;
import com.spoonacular.client.model.GetShoppingList200Response;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for MealPlanningApi
 */
@Disabled
public class MealPlanningApiTest {

    private final MealPlanningApi api = new MealPlanningApi();

    /**
     * Add Meal Plan Template
     *
     * Add a meal plan template for a user.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addMealPlanTemplateTest() throws ApiException {
        String username = null;
        String hash = null;
        AddToMealPlanRequest addToMealPlanRequest = null;
        AddMealPlanTemplate200Response response = api.addMealPlanTemplate(username, hash, addToMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Add to Meal Plan
     *
     * Add an item to the user&#39;s meal plan.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addToMealPlanTest() throws ApiException {
        String username = null;
        String hash = null;
        AddToMealPlanRequest addToMealPlanRequest = null;
        Object response = api.addToMealPlan(username, hash, addToMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Add to Shopping List
     *
     * Add an item to the current shopping list of a user.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addToShoppingListTest() throws ApiException {
        String username = null;
        String hash = null;
        AddToMealPlanRequest addToMealPlanRequest = null;
        GenerateShoppingList200Response response = api.addToShoppingList(username, hash, addToMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Clear Meal Plan Day
     *
     * Delete all planned items from the user&#39;s meal plan for a specific day.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void clearMealPlanDayTest() throws ApiException {
        String username = null;
        String date = null;
        String hash = null;
        ClearMealPlanDayRequest clearMealPlanDayRequest = null;
        Object response = api.clearMealPlanDay(username, date, hash, clearMealPlanDayRequest);
        // TODO: test validations
    }

    /**
     * Connect User
     *
     * In order to call user-specific endpoints, you need to connect your app&#39;s users to spoonacular users.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void connectUserTest() throws ApiException {
        Object body = null;
        ConnectUser200Response response = api.connectUser(body);
        // TODO: test validations
    }

    /**
     * Delete from Meal Plan
     *
     * Delete an item from the user&#39;s meal plan.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteFromMealPlanTest() throws ApiException {
        String username = null;
        BigDecimal id = null;
        String hash = null;
        DeleteFromMealPlanRequest deleteFromMealPlanRequest = null;
        Object response = api.deleteFromMealPlan(username, id, hash, deleteFromMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Delete from Shopping List
     *
     * Delete an item from the current shopping list of the user.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteFromShoppingListTest() throws ApiException {
        String username = null;
        Integer id = null;
        String hash = null;
        DeleteFromMealPlanRequest deleteFromMealPlanRequest = null;
        Object response = api.deleteFromShoppingList(username, id, hash, deleteFromMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Delete Meal Plan Template
     *
     * Delete a meal plan template for a user.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteMealPlanTemplateTest() throws ApiException {
        String username = null;
        Integer id = null;
        String hash = null;
        DeleteFromMealPlanRequest deleteFromMealPlanRequest = null;
        Object response = api.deleteMealPlanTemplate(username, id, hash, deleteFromMealPlanRequest);
        // TODO: test validations
    }

    /**
     * Generate Meal Plan
     *
     * Generate a meal plan with three meals per day (breakfast, lunch, and dinner).
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void generateMealPlanTest() throws ApiException {
        String timeFrame = null;
        BigDecimal targetCalories = null;
        String diet = null;
        String exclude = null;
        GenerateMealPlan200Response response = api.generateMealPlan(timeFrame, targetCalories, diet, exclude);
        // TODO: test validations
    }

    /**
     * Generate Shopping List
     *
     * Generate the shopping list for a user from the meal planner in a given time frame.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void generateShoppingListTest() throws ApiException {
        String username = null;
        String startDate = null;
        String endDate = null;
        String hash = null;
        GenerateShoppingListRequest generateShoppingListRequest = null;
        GenerateShoppingList200Response response = api.generateShoppingList(username, startDate, endDate, hash, generateShoppingListRequest);
        // TODO: test validations
    }

    /**
     * Get Meal Plan Template
     *
     * Get information about a meal plan template.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getMealPlanTemplateTest() throws ApiException {
        String username = null;
        Integer id = null;
        String hash = null;
        GetMealPlanTemplate200Response response = api.getMealPlanTemplate(username, id, hash);
        // TODO: test validations
    }

    /**
     * Get Meal Plan Templates
     *
     * Get meal plan templates from user or public ones.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getMealPlanTemplatesTest() throws ApiException {
        String username = null;
        String hash = null;
        GetMealPlanTemplates200Response response = api.getMealPlanTemplates(username, hash);
        // TODO: test validations
    }

    /**
     * Get Meal Plan Week
     *
     * Retrieve a meal planned week for the given user. The username must be a spoonacular user and the hash must the the user&#39;s hash that can be found in his/her account.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getMealPlanWeekTest() throws ApiException {
        String username = null;
        String startDate = null;
        String hash = null;
        GetMealPlanWeek200Response response = api.getMealPlanWeek(username, startDate, hash);
        // TODO: test validations
    }

    /**
     * Get Shopping List
     *
     * Get the current shopping list for the given user.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getShoppingListTest() throws ApiException {
        String username = null;
        String hash = null;
        GetShoppingList200Response response = api.getShoppingList(username, hash);
        // TODO: test validations
    }

}
